﻿Imports System
Imports System.Collections
Imports System.Data
Imports System.Web
Imports System.Web.Script.Services
Imports System.Web.Services
Imports Data
Imports DayPilot.Utils
Imports DayPilot.Web.Ui
Imports DayPilot.Web.Ui.Enums
Imports DayPilot.Web.Ui.Events
Imports DayPilot.Web.Ui.Events.Scheduler
Imports Newtonsoft.Json

Partial Public Class _Default
	Inherits System.Web.UI.Page

	Private tasks As DataTable

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
		If Not IsPostBack Then
			DayPilotScheduler1.TimeHeaders.Clear()
			DayPilotScheduler1.TimeHeaders.Add(New TimeHeader(GroupByEnum.Month))
			DayPilotScheduler1.TimeHeaders.Add(New TimeHeader(GroupByEnum.Week))
			DayPilotScheduler1.TimeHeaders.Add(New TimeHeader(GroupByEnum.Day))

			LoadResources()
			UpdateScheduler()

			DayPilotScheduler1.SetScrollX(If((New DataManager()).GetStart(), Date.Today))
		End If
	End Sub

	Private Sub UpdateScheduler()
		tasks = (New DataManager()).GetTasks()
		Dim start = New Date(2021, 1, 1)
		Dim [end] = New Date(2022, 1, 1)

		DayPilotScheduler1.StartDate = start
		DayPilotScheduler1.Days = CInt(Math.Truncate(Math.Ceiling(([end] - start).TotalDays)))
		DayPilotScheduler1.DataSource = (New DataManager()).GetTasks()
		DayPilotScheduler1.DataBind()
		DayPilotScheduler1.Update()
	End Sub

	Private Sub LoadResources()
		Dim locations As DataTable = (New DataManager()).GetTasks()
		DayPilotScheduler1.Resources.Clear()
		DayPilotScheduler1.Resources.Add("New Task", "NEW")
		For Each dr As DataRow In locations.Rows
			DayPilotScheduler1.Resources.Add(DirectCast(dr("TaskName"), String), Convert.ToString(dr("TaskId")))
		Next dr
	End Sub

	Protected Sub DayPilotCalendar1_EventMenuClick(ByVal sender As Object, ByVal e As EventMenuClickEventArgs)
		Select Case e.Command
			Case "Delete"
'NOTE: The variable id was renamed since Visual Basic does not handle local variables named the same as class members well:
				Dim id_Renamed As Integer = If(e.Recurrent, Convert.ToInt32(e.RecurrentMasterId), Convert.ToInt32(e.Value))
				Call (New DataManager()).DeleteTask(id_Renamed)
				UpdateScheduler()
				LoadResources()
				DayPilotScheduler1.Update(CallBackUpdateType.Full)


		End Select
	End Sub

	Protected Sub DayPilotCalendar1_EventResize(ByVal sender As Object, ByVal e As EventResizeEventArgs)
'NOTE: The variable id was renamed since Visual Basic does not handle local variables named the same as class members well:
		Dim id_Renamed As Integer = If(e.Recurrent, Convert.ToInt32(e.RecurrentMasterId), Convert.ToInt32(e.Value))
		Call (New DataManager()).MoveTask(id_Renamed, e.NewStart, e.NewEnd)
		LoadResources() ' update order
		UpdateScheduler()
	End Sub

	Protected Sub DayPilotCalendar1_Command(ByVal sender As Object, ByVal e As CommandEventArgs)
		Select Case e.Command
			Case "refresh"
				UpdateScheduler()
				LoadResources()
				DayPilotScheduler1.Update(CallBackUpdateType.Full)

		End Select
	End Sub

	Protected Sub DayPilotCalendar1_BeforeEventRender(ByVal sender As Object, ByVal e As BeforeEventRenderEventArgs)
		e.InnerHTML = Server.HtmlEncode(e.Text)
		e.EventMoveVerticalEnabled = False
		e.StaticBubbleHTML = String.Format("<b>{0}</b><br/>Start: {1}<br/>End: {2}", e.Text, e.Start, e.End)

	End Sub

	Protected Sub DayPilotCalendar1_EventMove(ByVal sender As Object, ByVal e As EventMoveEventArgs)
'NOTE: The variable id was renamed since Visual Basic does not handle local variables named the same as class members well:
		Dim id_Renamed As Integer = If(e.Recurrent, Convert.ToInt32(e.RecurrentMasterId), Convert.ToInt32(e.Value))
		Call (New DataManager()).MoveTask(id_Renamed, e.NewStart, e.NewEnd)
		LoadResources() ' update order
		UpdateScheduler()
	End Sub
	Protected Sub DayPilotScheduler1_BeforeCellRender(ByVal sender As Object, ByVal e As BeforeCellRenderEventArgs)
	End Sub

	Protected Sub DayPilotScheduler1_BeforeTimeHeaderRender(ByVal sender As Object, ByVal e As BeforeTimeHeaderRenderEventArgs)
		If e.Level = 1 Then
			e.InnerHTML = String.Format("Week {0}", Week.WeekNrISO8601(e.Start))
		End If
	End Sub

	<WebMethod(EnableSession := True), ScriptMethod(ResponseFormat := ResponseFormat.Json)>
	Public Shared Function CreateTask(ByVal start As Date, ByVal [end] As Date, ByVal text As String) As String
		Call (New DataManager()).CreateTask(start, [end], text)
		Dim result As New Hashtable()
		result("status") = "OK"
		Return JsonConvert.SerializeObject(result)
	End Function


	<WebMethod(EnableSession := True), ScriptMethod(ResponseFormat := ResponseFormat.Json)>
	Public Shared Function UpdateTask(ByVal id As Integer, ByVal start As Date, ByVal [end] As Date, ByVal text As String) As String
		Call (New DataManager()).UpdateTask(id, start, [end], text)
		Dim result As New Hashtable()
		result("status") = "OK"
		Return JsonConvert.SerializeObject(result)
	End Function

End Class
