/* Event editing helpers - modal dialog */
function dialog() {
    var modal = new DayPilot.Modal();
    modal.top = 60;
    modal.width = 250;
    modal.height = 150;
    modal.opacity = 70;
    modal.border = "10px solid #d0d0d0";
    modal.closed = function () {
        if (this.result == "OK") {
            dp.commandCallBack('refresh');
        }
        dp.clearSelection();
    };
    return modal;
}

async function timeRangeSelected(start, end, resource) {
    if (resource !== 'NEW') {
        dp.clearSelection();
        dp.message("Use the 'New Task' row");
        return;
    }

    const form = [
        { name: "Text", id: "text" },
        { name: "Start", id: "start", type: "date" },
        { name: "End", id: "end", type: "date" }
    ];

    const data = {
        start,
        end
    };

    const modal = await DayPilot.Modal.form(form, data);

    if (modal.canceled) {
        return;
    }

    DayPilot.Http.ajax({
        url: "Default.aspx/CreateTask",
        data: modal.result,
        success: function (ajax) {
            dp.commandCallBack("refresh");
            dp.message("Created");
        }
    });

}

async function eventClick(e) {
    const form = [
        { name: "Text", id: "text" },
        { name: "Start", id: "start", type: "date" },
        { name: "End", id: "end", type: "date" },
    ];

    const data = e.data;

    const modal = await DayPilot.Modal.form(form, data);

    if (modal.canceled) {
        return;
    }

    DayPilot.Http.ajax({
        url: "Default.aspx/UpdateTask",
        data: modal.result,
        success: function (ajax) {
            dp.commandCallBack("refresh");
            dp.message("Created");
        }
    });

}

function afterRender() {
}

